/*
*** anillo.c ***
Área de Arquitectura y Tecnología de Computadores
EUPT: Sistemas Operativos II
*/
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <stdlib.h>

int Realiza_Operacion(int num_1, int num_2);
void  handler();

int hijo1, hijo2, hijo3;

int main(int argc, char *argv[]){
  int pid_t, pidaux, pidwait;
  int numero, alarma, nuevo_numero, nbytes;
  int buf = 0, status = 0, cont_hijos_fin = 0;    
  int fpipe[3][2];

  pipe(fpipe[0]);
  pipe(fpipe[1]);
  pipe(fpipe[2]);

  numero = atoi(argv[1]);
  alarma = atoi(argv[2]);
  printf("\n Paso 1 del testigo: %d", numero); 
  printf("\n Tiempo máximo permitido para la ejecución %d seg.\n", alarma); 
  alarm(alarma);
  fflush(stdout); 
  sleep(1); 
  if ((hijo1 = fork()) == 0) 
  {     
    close(fpipe[0][1]); 
    close(fpipe[1][0]); 
    close(fpipe[2][0]); 
    close(fpipe[2][1]); 

    read(fpipe[0][0], &buf, 4);
    nuevo_numero = Realiza_Operacion(numero, buf);
    printf("\n Paso 2 del testigo: %d", nuevo_numero); fflush(stdout);

    write(fpipe[1][1], &nuevo_numero, 4);
    exit(1);
  }
  
  if ((hijo2 = fork()) == 0)
  {
    close(fpipe[0][0]);
    close(fpipe[0][1]);
    close(fpipe[1][1]);
    close(fpipe[2][0]);

    read(fpipe[1][0], &buf, 4);
    
    nuevo_numero = Realiza_Operacion(numero, buf);
    printf("\n Paso 3 del testigo: %d", nuevo_numero); 
    fflush(stdout);
 
    write(fpipe[2][1], &nuevo_numero, 4);
    exit(2);
  }

  if ((hijo3 = fork()) == 0)
  {
    close(fpipe[0][0]);
    close(fpipe[1][0]);
    close(fpipe[1][1]);
    close(fpipe[2][1]);

    read(fpipe[2][0], &buf, 4);
    nuevo_numero = Realiza_Operacion(numero, buf);
    printf("\n Paso 4 del testigo: %d", nuevo_numero); fflush(stdout);
    write(fpipe[0][1], &nuevo_numero, 4);
    exit(3);
  }
   signal(SIGALRM, handler);
  sleep(10); //Todos los procesos hijos deben de estar en ejecucion

  write(fpipe[0][1], &numero, 4);
  close(fpipe[0][1]);
  nbytes = read(fpipe[0][0], &buf, 4);
  waitpid(hijo1, &status, 0);  
  printf("\n Proceso %d ha finalizado y su estado es %d", hijo1, status);
  waitpid(hijo2, &status, 0);
  printf("\n Proceso %d ha finalizado y su estado es %d", hijo2, status);
  waitpid(hijo3, &status, 0);
  printf("\n Proceso %d ha finalizado y su estado es %d", hijo3, status);
  if (nbytes == 4)
    printf("\n El resultado de la ejecución del anillo es: %d \n", buf);
  else
    printf("\n La ejecución del anillo ha sido INCORRECTA. \n");
  
  exit(0);
}   



int Realiza_Operacion(int num_1, int num_2)
{
  int num_opera;
  /* */
  // Nuevo código de la función;
  /* */
  num_opera = num_1 * num_2;
  return(num_opera);
}

void  handler()
{
  kill(hijo1, SIGKILL);
  kill(hijo2, SIGKILL);
  kill(hijo3, SIGKILL);
  printf("La ejecucion ha sido abortada por incumpliento del tiempo");
  exit(-1);
}