
/*     Sistemas Operativos II     */
/*     prac3.c     */
	
#include <sys/types.h>
#include <sys/wait.h>

#include <stdio.h>

void pr_exit(int estado);

int main()
{
  pid_t pid;
  int status;


  if ((pid = fork()) < 0) perror("fork error");
  else if (pid == 0) exit(7);

  if (wait(&status) != pid) perror("wait error");
  pr_exit(status);

  if ((pid = fork()) < 0) perror("fork error");
  else if (pid == 0) abort();

  if (wait(&status) != pid) perror("wait error");
  pr_exit(status);

  if ((pid = fork()) < 0) perror("fork error");
  else if (pid == 0) status = status / 0;

  if (wait(&status) != pid) perror("wait error");
  pr_exit(status);
	
	printf("\n Prueba hijos STOPPED	\n"); fflush(stdout);
	
	if ((pid = fork()) < 0) perror("fork error");
	else if (pid == 0)
	{
		sleep(40);
		kill (getpid(), SIGSTOP);
		exit(11);
	}

	if (waitpid(pid, &status, WUNTRACED) != pid) perror("waitpid error");
	pr_exit(status);
	
	printf("\n Enva seal SIGCONT o seal de Fin al proceso PDI: %d \n", pid); fflush(stdout);
	
	if (wait(&status) != pid) perror("wait error");
	pr_exit(status);
	
  exit(0);
}

void pr_exit(int estado)
{
  if (WIFEXITED(estado)) printf("Terminacin normal, exit status = %d\n", WEXITSTATUS(estado));
  else if (WIFSIGNALED(estado))
  {
    printf("Terminacin anormal, numero de signal = %d ", WTERMSIG(estado));
    if (WCOREDUMP(estado)) printf("(se genero fichero core)\n");
    else printf(" \n");
  }
  else if (WIFSTOPPED(estado)) printf("Hijo detenido, numero de signal = %d\n", WSTOPSIG(estado));
}
