#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>

union semun {
     int              val;    /* Value for SETVAL */
     struct semid_ds *buf;    /* Buffer for IPC_STAT, IPC_SET */
     unsigned short  *array;  /* Array for GETALL, SETALL */
     struct seminfo  *__buf;  /* Buffer for IPC_INFO
     (Linux-specific) */
};

void op_signal(int sem, int n)
{
  struct sembuf sop;/* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = 1;/* Operación signal o liberar una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación signal propiamente dicha */
}

void op_wait(int sem, int n)
{
  struct sembuf sop;  /* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = -1;/* Operación wait u obtención una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación wait propiamente dicha */
}



int main(int argc, char* argv[]) {
  int key=5;
  int n=6;
  int nfilosofo;
  int semid;
  int time;
  int aux;

  
  semid=semget(key, n, 0);
  nfilosofo=atoi(argv[1]);
  time=atoi(argv[2]);
  aux=(nfilosofo+1) % 5;
  while (1) {      
    printf("%d PENSANDO\n", nfilosofo); fflush(stdout);   
    sleep(time);
    if (nfilosofo%2==0) { //SI ES PAR
      op_wait(semid, nfilosofo);
      op_wait(semid, aux);    
      
      
    } else {  //SI ES IMPAR
      op_wait(semid, aux);      
      op_wait(semid, nfilosofo); 
    }  
    
    printf("%d COMIENDO\n", nfilosofo); fflush(stdout);
    sleep(time);
    op_signal(semid, nfilosofo);    
    op_signal(semid, aux);
  }
}
